Index: coreboot-v2/src/boot/Config.lb
===================================================================
--- coreboot-v2.orig/src/boot/Config.lb
+++ coreboot-v2/src/boot/Config.lb
@@ -1,7 +1,8 @@
-object elfboot.o
 object hardwaremain.o
 if CONFIG_CBFS
 	object selfboot.o
+else
+	object elfboot.o
 end
 if CONFIG_FS_PAYLOAD
 	object filo.o
Index: coreboot-v2/src/stream/Config.lb
===================================================================
--- coreboot-v2.orig/src/stream/Config.lb
+++ coreboot-v2/src/stream/Config.lb
@@ -3,7 +3,10 @@ uses CONFIG_IDE_PAYLOAD
 uses CONFIG_FS_PAYLOAD
 uses CONFIG_IDE
 uses CONFIG_SERIAL_PAYLOAD
+uses CONFIG_CBFS
 
+if CONFIG_CBFS
+else
 if CONFIG_ROM_PAYLOAD
   object rom_stream.o
 end
@@ -21,3 +24,4 @@ end
 if CONFIG_SERIAL_PAYLOAD
   object serial_stream.o
 end
+end
Index: coreboot-v2/src/boot/hardwaremain.c
===================================================================
--- coreboot-v2.orig/src/boot/hardwaremain.c
+++ coreboot-v2/src/boot/hardwaremain.c
@@ -103,7 +103,7 @@ void hardwaremain(int boot_complete)
 # else
 	void (*pl)(void) = cbfs_load_payload(lb_mem, "normal/payload");
 # endif
-#endif
+#else
 
 #if CONFIG_FS_PAYLOAD == 1
 #warning "CONFIG_FS_PAYLOAD is deprecated."
@@ -112,6 +112,7 @@ void hardwaremain(int boot_complete)
 #warning "elfboot will soon be deprecated."
 	elfboot(lb_mem);
 #endif
+#endif
 	printk_err("Boot failed.\n");
 }
 
